//+------------------------------------------------------------------+
//|                                                    Lock open.mq4 |
//|                                           Copyright  2010, Alex |
//|                                                          http:// |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Alex"
#property link      "http://"

//---- input parameters
extern int       TralingOrders = 100;
extern double    Lots = 1;
extern int       Maperiod1 = 15;
extern int       Maperiod2 = 20;
extern int       TakeProfit = 100;
extern int       StopOrders = 400;
extern int       decrease = 15;
extern double    Equity = 25000;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int start()
  {
  if(AccountEquity()>Equity) CloseAllPositions();
  if(OrdersTotal()==0) OpenPosition();
  else
     {
     
     for(int i=0;i<OrdersTotal();i++)
     {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
     if(OrderMagicNumber()!=1 && OrderMagicNumber()!=2 && OrderMagicNumber()!=3) continue;    
      if(OrderType()!=OP_BUYSTOP && OrderType()!=OP_SELLSTOP)
         {
         if(OrderMagicNumber()==2)OrderIsnModify();
         if(OrderProfit()>0) OtlozgnOrders();
         }
       if(OrderType()!=OP_BUY && OrderType()!=OP_SELL) TralOrderOtl(OrderTicket());
       }     
      
    }
    
  return;
  }
  void OpenPosition()
  {
// ----
    double ma1=iMA(NULL,0, Maperiod1,0,1,0,1);
    double ma2=iMA(NULL,0, Maperiod1,0,1,0,2);
    double ma3=iMA(NULL,0, Maperiod2,0,1,0,1);
    double ma4=iMA(NULL,0, Maperiod2,0,1,0,2);
    if(ma1>ma3 && ma2<ma4)
      {
       RefreshRates();
        int res=OrderSend(Symbol(),OP_SELL,Lots, Bid, 20, 0, Bid-TakeProfit*Point, "....", 1,0,Red);
       
        int res2=OrderSend(Symbol(),OP_BUYSTOP,Lots, Bid+StopOrders*Point, 20, 0, 0, "....", 2,0,Red);
      }
   if(ma1<ma3 && ma2>ma4)
     {
         
         res=OrderSend(Symbol(),OP_BUY,Lots, Ask, 20, 0, Bid+TakeProfit*Point, "....", 1,0,Red);
         
         res2=OrderSend(Symbol(),OP_SELLSTOP,Lots, Bid-StopOrders*Point, 20, 0, 0, "....", 2,0,Red);
      }
  return;
  }
//   ----
void OtlozgnOrders()
{
double max=High[1];
for( int i=1; i<7; i++)
    {
    if(High[i]>max) max=High[i];
    }
double min=Low[1];
for( i=1; i<6; i++)
    {
    if(Low[i]<min) min=Low[i];
    }
    
 for(i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderSymbol()!=Symbol()) continue;
      if(OrderType()==OP_BUY && OrderProfit()>0 && Ask<min)
         {
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),Bid, 20, Red);
         
         int res3=OrderSend(Symbol(),OP_BUYSTOP, Lots, max+decrease*Point,20,0,0,"...",3,0, Red);
         
         }
     if(OrderType()==OP_SELL && OrderProfit()>0  && Bid>max)
        {
        OrderClose(OrderTicket(),OrderLots(),Ask, 20, Red);
        
        res3=OrderSend(Symbol(),OP_SELLSTOP, Lots, min-decrease*Point,20,0,0,"...",3,0, Red);
        
        }
      }
   return(0);
  }
  void TralOrderOtl(int ticket)
  {
  double max=High[1];
for( int i=1; i<6; i++)
    {
    if(High[i]>max) max=High[i];
    }
double min=Low[1];
for( i=1; i<6; i++)
    {
    if(Low[i]<min) min=Low[i];
    }
 
      OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);
      
        
         if(OrderType()==4)   // long position is opened
           {
           
                        
               if(Bid-OrderOpenPrice()>2*Point*TralingOrders)
                 {
                  
                     OrderModify(OrderTicket(),Ask+1.5*Point*TralingOrders,OrderStopLoss(),OrderTakeProfit(),OrderExpiration(),Green);
                    Alert(GetLastError());
                   
                 }
              }
           
        if(OrderType()==5)// go to short position
           {
           
            
               if(OrderOpenPrice()-Ask>2*Point*TralingOrders)
                 {
                  
                     bool r=OrderModify(ticket,Bid-1.5*Point*TralingOrders,OrderStopLoss(),OrderTakeProfit(),OrderExpiration(),Red);
                     
                   Alert(r);
                 }
              }
           
       
       
     
  return;
  }
  void OrderIsnModify()
  {
  for(int i=0;i<OrdersTotal();i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==1 && OrderTakeProfit()>0) OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),0,0,Green);
     }
   return;
   } 
 void CloseAllPositions()
 {
 Alert(AccountEquity());
 for(int i=0;i<OrdersTotal();i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())
        {
        
          if(OrderType()==OP_BUY)
            {
              OrderClose(OrderTicket(),OrderLots(),Bid, 20, Red);
            }
          if(OrderType()==OP_SELL)
            {
              OrderClose(OrderTicket(),OrderLots(),Ask, 20, Red);
            }
          if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)
             {
             OrderDelete(OrderTicket());
             }
           }
         }
     return;
     }
//+------------------------------------------------------------------+